VERSION 5.00
Begin VB.Form frmTestPriorities 
   Caption         =   "Thread and Class Priorities"
   ClientHeight    =   2565
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6120
   LinkTopic       =   "Form1"
   ScaleHeight     =   2565
   ScaleWidth      =   6120
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      Height          =   345
      Left            =   180
      TabIndex        =   7
      Text            =   "10000"
      Top             =   585
      Width           =   1770
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Do it"
      Height          =   360
      Left            =   180
      TabIndex        =   5
      Top             =   1695
      Width           =   1770
   End
   Begin VB.ComboBox Combo2 
      Height          =   315
      Left            =   2610
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   1875
      Width           =   3465
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   2625
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   1200
      Width           =   3450
   End
   Begin VB.Frame Frame1 
      Caption         =   "Count to"
      Height          =   1905
      Left            =   60
      TabIndex        =   8
      Top             =   285
      Width           =   2010
      Begin VB.Label Label5 
         Caption         =   "0"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   18
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   555
         Left            =   150
         TabIndex        =   9
         Top             =   810
         Width           =   1815
      End
   End
   Begin VB.Label labStatus 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Label5"
      Height          =   270
      Left            =   0
      TabIndex        =   6
      Top             =   2295
      Width           =   6105
   End
   Begin VB.Label Label4 
      Caption         =   "Thread priority"
      Height          =   360
      Left            =   2295
      TabIndex        =   4
      Top             =   1605
      Width           =   1440
   End
   Begin VB.Label Label3 
      Caption         =   "Process priority"
      Height          =   285
      Left            =   2295
      TabIndex        =   3
      Top             =   930
      Width           =   1350
   End
   Begin VB.Label Label2 
      Caption         =   $"TestPriorities.frx":0000
      Height          =   795
      Left            =   2265
      TabIndex        =   0
      Top             =   30
      Width           =   3855
   End
End
Attribute VB_Name = "frmTestPriorities"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'By Arthur Marks, arthurruhtra@netscape.net
'Use at your own risk...

Private bByProgram As Boolean

Private Sub Combo1_Click()
    If Combo1.ListIndex < 0 Then Exit Sub
    If Not bByProgram Then ProcessPriority = Combo1.ItemData(Combo1.ListIndex)
    labStatus = "Process Priority = " & ProcessPriority & "     Thread priority = " & ThreadPriority
End Sub

Private Sub Combo2_Click()
    If Combo1.ListIndex < 0 Then Exit Sub
    If Not bByProgram Then ThreadPriority = Combo2.ItemData(Combo2.ListIndex)
    labStatus = "Process Priority = " & ProcessPriority & "     Thread priority = " & ThreadPriority
End Sub

Private Sub Command1_Click()
    Dim i As Long
    For i = 1 To Val(Text1)
        Label5 = i
        Label5.Refresh
    Next
End Sub

Private Sub Form_Load()
    bByProgram = True
    
    Combo1.Clear
    Combo2.Clear
    
    Combo1.AddItem IDLE_PRIORITY_CLASS & " IDLE_PRIORITY_CLASS"
    Combo1.ItemData(Combo1.NewIndex) = IDLE_PRIORITY_CLASS
    Combo1.AddItem NORMAL_PRIORITY_CLASS & " NORMAL_PRIORITY_CLASS"
    Combo1.ItemData(Combo1.NewIndex) = NORMAL_PRIORITY_CLASS
    Combo1.AddItem HIGH_PRIORITY_CLASS & " HIGH_PRIORITY_CLASS"
    Combo1.ItemData(Combo1.NewIndex) = HIGH_PRIORITY_CLASS
    Combo1.AddItem REALTIME_PRIORITY_CLASS & " REALTIME_PRIORITY_CLASS"
    Combo1.ItemData(Combo1.NewIndex) = REALTIME_PRIORITY_CLASS
    
    Combo2.AddItem THREAD_PRIORITY_IDLE & " THREAD_PRIORITY_IDLE"
    Combo2.ItemData(Combo2.NewIndex) = THREAD_PRIORITY_IDLE
    Combo2.AddItem THREAD_PRIORITY_LOWEST & " THREAD_PRIORITY_LOWEST"
    Combo2.ItemData(Combo2.NewIndex) = THREAD_PRIORITY_LOWEST
    Combo2.AddItem THREAD_PRIORITY_BELOW_NORMAL & " THREAD_PRIORITY_BELOW_NORMAL"
    Combo2.ItemData(Combo2.NewIndex) = THREAD_PRIORITY_BELOW_NORMAL
    Combo2.AddItem THREAD_PRIORITY_NORMAL & " THREAD_PRIORITY_NORMAL"
    Combo2.ItemData(Combo2.NewIndex) = THREAD_PRIORITY_NORMAL
    Combo2.AddItem THREAD_PRIORITY_ABOVE_NORMAL & " THREAD_PRIORITY_ABOVE_NORMAL"
    Combo2.ItemData(Combo2.NewIndex) = THREAD_PRIORITY_ABOVE_NORMAL
    Combo2.AddItem THREAD_PRIORITY_HIGHEST & " THREAD_PRIORITY_HIGHEST"
    Combo2.ItemData(Combo2.NewIndex) = THREAD_PRIORITY_HIGHEST
    Combo2.AddItem THREAD_PRIORITY_TIME_CRITICAL & " THREAD_PRIORITY_TIME_CRITICAL"
    Combo2.ItemData(Combo2.NewIndex) = THREAD_PRIORITY_TIME_CRITICAL
    
    bByProgram = False
    
    labStatus = "Process Priority = " & ProcessPriority & "     Thread priority = " & ThreadPriority

End Sub

Private Sub Form_Unload(Cancel As Integer)
    'I tried making the exe after leaving without resetting the priorities
    '(which are shared by the VB IDE) and it couldn't run some of the processes
    'needed
    
    ProcessPriority = NORMAL_PRIORITY_CLASS
    ThreadPriority = THREAD_PRIORITY_NORMAL
End Sub
